// 动画加载页面 目录封装  懒加载字体 工具栏效果 图片点击下滑
let total = document.querySelector('.total-contain')
let loading = document.querySelector('.loading')
loading.style.display = 'block'
total.style.display = 'none'
window.onload = function () {
    loading.style.display = 'none'
    total.style.display = 'block'

    //目录封装(html有目录才会执行)
    let catlogue = document.querySelector('.catlogue')
    // 第二种导航目录形式
    let suspend = document.querySelector('.suspend')
    if (catlogue) {
        // let catTitle = document.querySelectorAll('h1,h2,h3,h4')
        let catTitle = document.querySelectorAll('h1,h3')
        const smallTitle = document.getElementsByTagName('h3')
        const catList = new Array()
        // 不是一级标题要缩进
        for (let i = 0; i < smallTitle.length; i++) {
            smallTitle[i].innerHTML = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + smallTitle[i].innerHTML
        }
        // 如果需要目录才会添加节点
        // 添加子节点并给子节点添加类名
        for (let i = 0; i < catTitle.length; i++) {
            catList[i] = document.createElement('div')
            catList[i].classList.add("catlogue-item");
            catList[i].innerText = catTitle[i].innerText;
            catlogue.appendChild(catList[i]);
        }

        for (let i = 0; i < catList.length; i++) {
            catList[i].onclick = function () {
                for (let j = 0; j < catList.length; j++) {
                    if (j != i) {
                        catList[j].classList.remove('active')
                    }
                }
                document.documentElement.scrollTop = catTitle[i].offsetTop - 70
                if (suspend) {
                    document.documentElement.scrollTop = catTitle[i].offsetTop - 120
                }
                catList[i].classList.add('active')
            }
        }

        // 监听目录滚动
        window.addEventListener('scroll', function () {
            //所有锚点元素的 offsetTop
            const offsetTopArr = [];
            catTitle.forEach((item) => {
                offsetTopArr.push(item.offsetTop);
            });
            // 获取当前文档流的 scrollTop
            const scrollTop =
                document.documentElement.scrollTop || document.body.scrollTop;

            // 定义当前点亮的导航下标
            for (let i = 0; i < offsetTopArr.length; i++) {
                if ((scrollTop + 200) >= offsetTopArr[i]) {
                    catList[i].classList.add('active')
                    if (suspend) {
                        catList[i].classList.add('move')
                    }
                    for (let j = 0; j < catList.length; j++) {
                        if (j != i) {
                            catList[j].classList.remove('active')
                            if (suspend) {
                                catList[j].classList.remove('move')
                            }
                        }
                    }
                } else {
                    catList[i].classList.remove('active')
                    if (suspend) {
                        catList[i].classList.remove('move')
                    }
                }
            }
        })
    }

    // 懒加载字体
    function lazyLoad() {
        let overview = document.querySelector('.overview')
        let scrollTop = document.body.scrollTop || document.documentElement.scrollTop;
        let winHeight = window.innerHeight;
        let timer;
        overview.style.opacity = '0'
        if (overview.offsetTop < scrollTop + winHeight) {
            timer = setInterval(() => {
                overview.style.opacity = Number(overview.style.opacity) + 0.1
                if (Number(overview.style.opacity) == 1) {
                    clearInterval(timer)
                    overview.style.opacity = 1;
                    const typeWriter = document.querySelector('.firstOverview');
                    const typeContribution = document.querySelector('.firstContribution')
                    if (typeWriter) {
                        const text = 'Our project aims to...';
                        typeWriter.innerHTML = text;
                        typeWriter.style.setProperty('--characters', text.length);
                    } else if (typeContribution) {
                        const text = 'In our experiment...';
                        typeContribution.innerHTML = text;
                        typeContribution.style.setProperty('--characters', text.length);
                    }
                    window.removeEventListener('scroll', lazyLoad)
                }
            }, 100)

        }
    }
    window.addEventListener('scroll', lazyLoad)

    // 图片点击下滑
    let pullDown = document.querySelector('.design-img2')
    let picture = document.querySelector('.design-img')
    pullDown.addEventListener('click', function () {
        var timer;
        timer = setInterval(function () {
            document.documentElement.scrollTop = Number(document.documentElement.scrollTop) + 20
            if (document.documentElement.scrollTop >= picture.scrollHeight) {
                clearInterval(timer)
            }
        }, 10)
    })

    // 显示工具栏
    let showCat = document.querySelector(".one");
    let catTools = document.querySelector('.catlogue')
    let back = document.querySelector(".two");
    let tool = document.querySelector('.hoverTool')
    let overviewArticle = document.querySelector('.overview')
    let mark = 0;
    // 默认绿色，有目录会出现橙色
    showCat.style.backgroundColor = '#28ae78'
    showCat.style.backgroundColor = '#53dcba'
    // 目录和文章同时存在的条件下
    if (overviewArticle && catTools) {
        showCat.style.backgroundColor = '#f4a926'
        if (suspend) {
            showCat.style.backgroundColor = '#28ae78'
            showCat.style.backgroundColor = '#53dcba'
        }
        if (!document.querySelector('.catlogue')) {
            showCat.style.backgroundColor = '#28ae78'
            showCat.style.backgroundColor = '#53dcba'
            overviewArticle.style.width = '90%'
            overviewArticle.style.margin = '0 auto'
        }
        if (window.innerWidth > 850) {
            showCat.onclick = function () {
                if (suspend) {
                    return
                } else {
                    if (mark == 1) {
                        catTools.style.display = 'block'
                        showCat.style.backgroundColor = '#f4a926'
                        overviewArticle.style.width = '80%'
                        mark = 0
                    } else {
                        overviewArticle.style.width = '90%'
                        overviewArticle.style.margin = '0 auto'
                        showCat.style.backgroundColor = '#28ae78'
                        showCat.style.backgroundColor = '#53dcba'
                        catTools.style.display = 'none'
                        mark = 1
                    }
                }
            }
        } else {
            // 屏幕小于850隐藏目录
            showCat.style.backgroundColor = '#28ae78'
        }
    }

    // 工具栏出现效果
    function backTop() {
        if (document.documentElement.scrollTop != 0) {
            tool.style.transform = 'translateX(' + 0 + 'px' + ')'
            tool.style.opacity = 1
        } else {
            tool.style.transform = 'translateX(' + 100 + 'px' + ')'
            tool.style.opacity = 1
        }
    }
    // 监听工具栏是否出现
    window.addEventListener("scroll", backTop);

    // 悬浮导航出现效果
    window.addEventListener('scroll', function () {
        if (document.documentElement.scrollTop != 0) {
            suspend.style.transform = 'translateX(' + 0 + 'px' + ')'
            suspend.style.opacity = 1
        } else {
            suspend.style.transform = 'translateX(' + 100 + 'px' + ')'
            suspend.style.opacity = 0
        }

    })

    // 点击回到顶部
    back.addEventListener('click', function () {
        let timer = null;
        if (timer != null) {
            clearInterval(timer);
        }
        timer = setInterval(function () {
            document.documentElement.scrollTop =
                Number(document.documentElement.scrollTop) - 20;
            if (document.documentElement.scrollTop <= 0) {
                clearInterval(timer);
            }
        }, 1);
    })


}



